//------------------------------------------------------------------------------
// ObjectPatchEx1.pov
//
// An example with more complex CSG objects, again using the patched POVRay
// code and not the ObjectAsIso.inc file.
//
// Note! This file will not run correctly as is, without the patched POVRay code.
//
//                                                               WFP 09/13/09
//------------------------------------------------------------------------------

#declare SimpleObjects = off; // on | off

camera { location  <3, 1.0,-5> look_at <0, 0, 0> angle 35}

sky_sphere { pigment {
    function{abs(y)}
    color_map { [0.0 color blue 0.6] [1.0 color rgb 1] }
  }
}

light_source {<-100, 200,-100> colour rgb 1.0}
light_source {< 100,-200, 100> colour rgb 0.2}

// ----------------------------------------

#include "functions.inc"

   #declare Thing1 =
     difference {
       box {-1,1}
       sphere {0,1.2}
     }

   #declare Thing2 =
     union {
       #local Xpos = -0.75;
       #while (Xpos < 1.0)
         #local Zpos = -0.75;
         #while (Zpos < 1.0)
           object { cylinder { <Xpos, -0.9, Zpos>, <Xpos, 0.9, Zpos>, 0.040 } }
           object { sphere   { <Xpos, -0.9, Zpos>,                    0.040 } }
           object { sphere   {                     <Xpos, 0.9, Zpos>, 0.040 } }
           #local Zpos = Zpos + 0.50;
         #end
         #local Xpos = Xpos + 0.50;
       #end
     }

//
// Using just a single Thing3 below works, but it runs in about 80 minutes
// instead of 50 minutes for the uncommented code, and the single Thing3
// has a higher max gradient.  Because the run times are large, even
// slight changes in the search time for an object make for very large
// differences in run time.  The three ObjectAsIso equations have the added
// advantage of blobbing/smoothing where the objects cross.
//
// #declare Thing3 =
//   union {
//     object { Thing2 }
//     object { Thing2 rotate x*-90 }
//     object { Thing2 rotate z*-90 }
//   }

   #declare Thing3 = object { Thing2 rotate x*-90 }
   #declare Thing4 = object { Thing2 rotate z*-90 }

   #if (SimpleObjects)
      object { union {
                 object { Thing2 }
                 object { Thing3 }
                 object { Thing4 }
               }
               texture { pigment { color rgb <1.00000,0.78824,0.00392> } }
             }
   #else
      object {
           #declare ObjectAsIso2 = function{pattern{object {Thing2}}}
           #declare ObjectAsIso3 = function{pattern{object {Thing3}}}
           #declare ObjectAsIso4 = function{pattern{object {Thing4}}}
           isosurface{
             function{0.100-(ObjectAsIso2(x,y,z)+
                             ObjectAsIso3(x,y,z)+
                             ObjectAsIso4(x,y,z))+(f_noise3d(40*x,40*y,40*z)/6) }
             accuracy     0.0001
             max_gradient 22
             all_intersections
             contained_by {box{-1.1,1.1}}
           }
        pigment {rgb 0.9}
        finish {phong 0.5 phong_size 10}
      }
   #end

